Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 585)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 712)
@@ -700,44 +859,133 @@
     } // end switch DMA_CMD FSM
 
-    //////////////////////////////////////////////////////////////////////////////
-    // The DMA_RSP_FSM handles the RAM responses to peripherals DMA transactions.
-    //////////////////////////////////////////////////////////////////////////////
-
-    switch( r_dma_rsp_fsm.read() ) 
-    {
-    //////////////////
-    case DMA_RSP_IDLE:  // waiting a response from RAM betwork
-    {    	
-        if ( p_vci_ini_ram.rspval.read() ) 
-		{
-			r_dma_rsp_fsm = DMA_RSP_FIFO_PUT;
-		}
-		break;
-    }
-    //////////////////////
-    case DMA_RSP_FIFO_PUT:
-    {
-        if(p_vci_ini_ram.rspval.read() and not r_alloc_fifo_dma_rsp_local.read() )
-    	{
-            dma_rsp_fifo_put = true;
-
-            if(p_vci_ini_ram.reop.read())   r_dma_rsp_fsm = DMA_RSP_IDLE;	
+    ////////////////////////////////////////////////////////////////////////////////
+    // The DMA_RSP_FSM controls access to the DMA_RSP FIFO to the IOX network.
+    // There exist 3 "clients" to send VCI responses on the IOX network:
+    // - request from p_vci_ini_ram    : normal DMA response from RAM network,
+    // - request from MISS_WTI_RSP FSM : normal WTI response from INT network,
+    // - request from DMA_CMD FSM      : bad address error response
+    // This FSM implements a round robin priority, with a "dead cycle" between
+    // two transactions. It could be optimized if throughput is critical...
+    ////////////////////////////////////////////////////////////////////////////////
+
+    // does nothing if FIFO is full
+    if ( m_dma_rsp_rerror_fifo.wok() )
+    {
+        switch( r_dma_rsp_fsm.read() ) 
+        {
+            //////////////////////
+            case DMA_RSP_IDLE_DMA:  // normal DMA response has highest priority
+            {    	
+                if     (p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
+                else if(r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI;
+                else if(r_dma_cmd_to_dma_rsp_req.read())      r_dma_rsp_fsm = DMA_RSP_PUT_ERR;
+                break;
+            }
+            //////////////////////
+            case DMA_RSP_IDLE_WTI:  // normal WTI response has highest priority
+            {    	
+                if     (r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI; 
+                else if(r_dma_cmd_to_dma_rsp_req.read())      r_dma_rsp_fsm = DMA_RSP_PUT_ERR;
+                else if(p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
+                break;
+            }
+            //////////////////////
+            case DMA_RSP_IDLE_ERR:  // error  response has highest priority
+            {    	
+                if     (r_dma_cmd_to_dma_rsp_req.read())      r_dma_rsp_fsm = DMA_RSP_PUT_ERR;
+                else if(p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
+                else if(r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI; 
+                break;
+            }
+            ///////////////////////
+            case DMA_RSP_PUT_DMA:  // put one flit of the DMA response into FIFO
+            {    	
+                dma_rsp_fifo_put    = true;
+                dma_rsp_fifo_rerror = p_vci_ini_ram.rerror.read();
+                dma_rsp_fifo_rdata  = p_vci_ini_ram.rdata.read();
+                dma_rsp_fifo_rsrcid = p_vci_ini_ram.rsrcid.read();
+                dma_rsp_fifo_rtrdid = p_vci_ini_ram.rtrdid.read();
+                dma_rsp_fifo_rpktid = p_vci_ini_ram.rpktid.read();
+                dma_rsp_fifo_reop   = p_vci_ini_ram.reop.read();
+
+                // update priority
+                if ( p_vci_ini_ram.reop.read() ) r_dma_rsp_fsm = DMA_RSP_IDLE_WTI;
 
 #if DEBUG_DMA_RSP
 if( m_debug_activated ) 
-std::cout << "  <IOB DMA_RSP_FIFO_PUT> Push response into DMA_RSP fifo:" 
-          << " / rsrcid = " << std::hex << p_vci_ini_ram.rsrcid.read()
+std::cout << "  <IOB DMA_RSP_PUT_DMA> Push DMA response into DMA_RSP FIFO" 
+          << " : rsrcid = " << std::hex << p_vci_ini_ram.rsrcid.read()
           << " / rtrdid = " << p_vci_ini_ram.rtrdid.read()
-          << " / rdata = " << std::hex << p_vci_ini_ram.rdata.read()
+          << " / rpktid = " << p_vci_ini_ram.rpktid.read()
+          << " / rdata = "  << p_vci_ini_ram.rdata.read()
           << " / rerror = " << p_vci_ini_ram.rerror.read()
-          << " / reop = " << p_vci_ini_ram.reop.read() << std::endl;
-#endif
-    	}
-    	break;
-    }
-    } // end switch DMA_RSP_FSM 
+          << " / reop = "   << p_vci_ini_ram.reop.read() << std::endl;
+#endif
+                break;
+		    }
+            ///////////////////////
+            case DMA_RSP_PUT_WTI:  // put single flit WTI response into FIFO
+            {    	
+                dma_rsp_fifo_put    = true;
+                dma_rsp_fifo_rerror = r_miss_wti_rsp_to_dma_rsp_rerror.read();
+                dma_rsp_fifo_rdata  = 0;
+                dma_rsp_fifo_rsrcid = r_miss_wti_rsp_to_dma_rsp_rsrcid.read();
+                dma_rsp_fifo_rtrdid = r_miss_wti_rsp_to_dma_rsp_rtrdid.read();
+                dma_rsp_fifo_rpktid = r_miss_wti_rsp_to_dma_rsp_rpktid.read();
+                dma_rsp_fifo_reop   = true;
+
+                // acknowledge request
+                r_miss_wti_rsp_to_dma_rsp_req = false;
+ 
+                // update priority
+                r_dma_rsp_fsm = DMA_RSP_IDLE_ERR;
+
+#if DEBUG_DMA_RSP
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_RSP_PUT_WTI> Push WTI response into DMA_RSP FIFO" 
+          << " : rsrcid = " << std::hex << r_miss_wti_rsp_to_dma_rsp_rsrcid.read()
+          << " / rtrdid = " << r_miss_wti_rsp_to_dma_rsp_rtrdid.read()
+          << " / rpktid = " << r_miss_wti_rsp_to_dma_rsp_rpktid.read()
+          << " / rdata = "  << 0
+          << " / rerror = " << r_miss_wti_rsp_to_dma_rsp_rerror.read()
+          << " / reop = "   << true << std::endl;
+#endif
+                break;
+            }
+            ///////////////////////
+            case DMA_RSP_PUT_ERR:  // put sinfle flit error response into FIFO
+            {
+                dma_rsp_fifo_put    = true;
+                dma_rsp_fifo_rerror = 0x1;
+                dma_rsp_fifo_rdata  = 0;
+                dma_rsp_fifo_rsrcid = r_dma_cmd_to_dma_rsp_rsrcid.read();
+                dma_rsp_fifo_rtrdid = r_dma_cmd_to_dma_rsp_rtrdid.read();
+                dma_rsp_fifo_rpktid = r_dma_cmd_to_dma_rsp_rpktid.read();
+                dma_rsp_fifo_reop   = true;
+
+                // acknowledge request
+                r_dma_cmd_to_dma_rsp_req = false;
+ 
+                // update priority
+                r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
+
+#if DEBUG_DMA_RSP
+if( m_debug_activated ) 
+std::cout << "  <IOB DMA_RSP_PUT_DMA> Push IOMMU ERROR response into DMA_RSP FIFO" 
+          << " : rsrcid = " << std::hex << r_dma_cmd_to_dma_rsp_rsrcid.read()
+          << " / rtrdid = " << r_dma_cmd_to_dma_rsp_rtrdid.read()
+          << " / rpktid = " << r_dma_cmd_to_dma_rsp_rpktid.read()
+          << " / rdata = "  << 0
+          << " / rerror = " << r_dma_cmd_to_dma_rsp_rerror.read()
+          << " / reop = "   << true << std::endl;
+#endif
+                break;
+            }
+		} // end switch DMA_RSP FSM
+    }  // end if FIFO full
+
 
     //////////////////////////////////////////////////////////////////////////////////
-    // The TLB FSM handles TLB miss request (from DMA_CMD FSM),
+    // The TLB FSM handles the TLB miss requests from DMA_CMD FSM,
     // and the PTE inval request (from CONFIG_CMD FSM).
     // PTE inval request have highest priority. In case of TLB miss, 
@@ -745,5 +993,5 @@
     // In case of buffer miss,  it request the MISS_WTI FSM to access the memory.
     // It bypass the first level page table access if possible.
-    // It reset the r_dma_tlb_req flip-flop to signal TLB miss completion.
+    // It reset the r_dma_cmd_to_tlb_req flip-flop to signal TLB miss completion.
     // An unexpected, but possible page fault is signaled in r_tlb_miss_error flip_flop.
     ////////////////////////////////////////////////////////////////////////////////////
@@ -755,12 +1003,12 @@
                      // PTE inval request are handled as unmaskable interrupts
     {
-        if ( r_config_tlb_req ) // Request from CONFIG FSM for a PTE invalidation 
+        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation 
         {
-            r_config_tlb_req      = false;
-            r_waiting_transaction = false;
-            r_tlb_fsm = TLB_INVAL_CHECK;
+            r_config_cmd_to_tlb_req  = false;
+            r_waiting_transaction    = false;
+            r_tlb_fsm                = TLB_INVAL_CHECK;
         }
 
-        else if ( r_dma_tlb_req.read() )   // request from DMA_CMD for a TLB Miss 
+        else if ( r_dma_cmd_to_tlb_req.read() )   // request for a TLB Miss 
         {
             // Checking prefetch buffer
@@ -769,7 +1017,7 @@
                 if( r_tlb_buf_valid &&         // Hit on prefetch buffer
                     (r_tlb_buf_vaddr.read() == 
-                    (r_dma_cmd_vaddr.read()& ~PTE2_LINE_OFFSET & ~K_PAGE_OFFSET_MASK)))
-                {
-                    size_t   pte_offset = (r_dma_cmd_vaddr.read()& PTE2_LINE_OFFSET)>>12; 
+                    (r_dma_cmd_to_tlb_vaddr.read()& ~PTE2_LINE_OFFSET & ~K_PAGE_OFFSET_MASK)))
+                {
+                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE2_LINE_OFFSET)>>12; 
                     uint32_t pte_flags  = r_tlb_buf_data[2*pte_offset];
                     uint32_t pte_ppn    = r_tlb_buf_data[2*pte_offset+1]; 
@@ -782,5 +1030,5 @@
                        
                         r_tlb_miss_error = true;
-                        r_dma_tlb_req    = false;
+                        r_dma_cmd_to_tlb_req    = false;
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
@@ -810,7 +1058,7 @@
                 if( r_tlb_buf_valid &&         // Hit on prefetch buffer
                     (r_tlb_buf_vaddr.read() == 
-                    (r_dma_cmd_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK ))) 
-                {
-                    size_t   pte_offset = (r_dma_cmd_vaddr.read()& PTE1_LINE_OFFSET)>>21; 
+                    (r_dma_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET & ~M_PAGE_OFFSET_MASK ))) 
+                {
+                    size_t   pte_offset = (r_dma_cmd_to_tlb_vaddr.read()& PTE1_LINE_OFFSET)>>21; 
                     uint32_t pte_flags  = r_tlb_buf_data[pte_offset];
                             
@@ -822,5 +1070,5 @@
                        
                         r_tlb_miss_error = true;
-                        r_dma_tlb_req    = false;
+                        r_dma_cmd_to_tlb_req    = false;
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
@@ -851,5 +1099,5 @@
 if ( m_debug_activated )
 std::cout << "  <IOB TLB_IDLE> Miss on prefetch buffer"
-          << std::hex << " / vaddr = " << r_dma_cmd_vaddr.read() << std::endl;
+          << std::hex << " / vaddr = " << r_dma_cmd_to_tlb_vaddr.read() << std::endl;
 #endif
         }
@@ -867,5 +1115,5 @@
 #endif
         // evaluate bypass in order to skip first level page table access
-        bypass = r_iotlb.get_bypass(r_dma_cmd_vaddr.read(), &ptba);
+        bypass = r_iotlb.get_bypass(r_dma_cmd_to_tlb_vaddr.read(), &ptba);
         
         // Request MISS_WTI_FSM a transaction on INT Network 
@@ -878,10 +1126,10 @@
 #endif
             pte_paddr = (vci_addr_t)((r_iommu_ptpr.read()) << (INDEX1_NBITS+2)) |
-                        (vci_addr_t)((r_dma_cmd_vaddr.read() >> PAGE_M_NBITS) << 2);
+                        (vci_addr_t)((r_dma_cmd_to_tlb_vaddr.read() >> PAGE_M_NBITS) << 2);
             r_tlb_paddr = pte_paddr;
             
-            r_tlb_miss_req     = true;
-            r_tlb_miss_type    = PTE1_MISS;
-            r_tlb_fsm          = TLB_WAIT;
+            r_tlb_to_miss_wti_cmd_req = true;
+            r_tlb_miss_type           = PTE1_MISS;
+            r_tlb_fsm                 = TLB_WAIT;
         }
         else                  // Read PTE2 in XRAM
@@ -894,11 +1142,11 @@
             //&PTE2 = PTBA + IX2 * 8
             pte_paddr = (vci_addr_t)ptba << PAGE_K_NBITS |
-                        (vci_addr_t)(r_dma_cmd_vaddr.read()&PTD_ID2_MASK)>>(PAGE_K_NBITS-3);
+                        (vci_addr_t)(r_dma_cmd_to_tlb_vaddr.read()&PTD_ID2_MASK)>>(PAGE_K_NBITS-3);
             
             r_tlb_paddr = pte_paddr;
             
-            r_tlb_miss_req     = true;
-            r_tlb_miss_type    = PTE2_MISS;
-            r_tlb_fsm          = TLB_WAIT;
+            r_tlb_to_miss_wti_cmd_req = true;
+            r_tlb_miss_type           = PTE2_MISS;
+            r_tlb_fsm                 = TLB_WAIT;
         }
 
@@ -929,6 +1177,6 @@
                        
             r_tlb_miss_error       = true;
-            r_dma_tlb_req         = false;
-            r_tlb_fsm             = TLB_IDLE;            
+            r_dma_cmd_to_tlb_req   = false;
+            r_tlb_fsm              = TLB_IDLE;            
 
 #if DEBUG_TLB_MISS
@@ -946,15 +1194,16 @@
         {
             // register bypass
-            r_iotlb.set_bypass( r_dma_cmd_vaddr.read(),
+            r_iotlb.set_bypass( r_dma_cmd_to_tlb_vaddr.read(),
                                 entry & ((1 << (vci_param_int::N-PAGE_K_NBITS)) - 1), 
                                 0); //nline, unused 
 
-            //&PTE2 = PTBA + IX2 * 8
+            // &PTE2 = PTBA + IX2 * 8
             // ps: PAGE_K_NBITS corresponds also to the size of a second level page table
             r_tlb_paddr = (vci_addr_t)(entry & ((1<<(vci_param_int::N-PAGE_K_NBITS))-1)) << PAGE_K_NBITS |
-                                (vci_addr_t)(((r_dma_cmd_vaddr.read() & PTD_ID2_MASK) >> PAGE_K_NBITS) << 3);
-            r_tlb_miss_req     = true;
-            r_tlb_miss_type    = PTE2_MISS;
-            r_tlb_fsm          = TLB_WAIT;
+                                (vci_addr_t)(((r_dma_cmd_to_tlb_vaddr.read() & PTD_ID2_MASK) >> PAGE_K_NBITS) << 3);
+
+            r_tlb_to_miss_wti_cmd_req = true;
+            r_tlb_miss_type           = PTE2_MISS;
+            r_tlb_fsm                 = TLB_WAIT;
 
 #ifdef INSTRUMENTATION
@@ -990,5 +1239,5 @@
         size_t 	set;
         
-        r_iotlb.select(  r_dma_cmd_vaddr.read(),
+        r_iotlb.select(  r_dma_cmd_to_tlb_vaddr.read(),
                         true,  // PTE1 
                         &way,
@@ -1016,5 +1265,5 @@
         
         r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_flags.read() & PPN1_MASK) << 21)
-                        | (r_dma_cmd_vaddr.read()& M_PAGE_OFFSET_MASK) );
+                        | (r_dma_cmd_to_tlb_vaddr.read()& M_PAGE_OFFSET_MASK) );
         
         // update TLB
@@ -1022,8 +1271,9 @@
                       pte,
                       0,		// argument unused for a PTE1
-                      r_dma_cmd_vaddr.read(),    
+                      r_dma_cmd_to_tlb_vaddr.read(),    
                       r_tlb_way.read(), 
                       r_tlb_set.read(),
                       0 );      //we set nline = 0
+
 #ifdef INSTRUMENTATION
 m_cpt_iotlb_write++;
@@ -1066,5 +1316,5 @@
                        
             r_tlb_miss_error       = true;
-            r_dma_tlb_req         = false;
+            r_dma_cmd_to_tlb_req         = false;
             r_tlb_fsm             = TLB_IDLE;            
 
@@ -1096,5 +1346,5 @@
         size_t set;
 
-        r_iotlb.select( r_dma_cmd_vaddr.read(),
+        r_iotlb.select( r_dma_cmd_to_tlb_vaddr.read(),
                         false,	// PTE2 
                         &way,
@@ -1106,9 +1356,7 @@
 #if DEBUG_TLB_MISS
 if ( m_debug_activated )
-{
-        std::cout << "  <IOB TLB_PTE2_SELECT> Select a slot in IOTLB:";
-        std::cout << " way = " << std::dec << way
-                  << " / set = " << set << std::endl;
-}
+std::cout << "  <IOB TLB_PTE2_SELECT> Select a slot in IOTLB:"
+          << " way = " << std::dec << way
+          << " / set = " << set << std::endl;
 #endif
         r_tlb_way = way;
@@ -1125,5 +1373,5 @@
         
         r_tlb_paddr = (vci_addr_t)( ((r_tlb_pte_ppn.read() & PPN2_MASK) << 12)
-                        | (r_dma_cmd_vaddr.read()& K_PAGE_OFFSET_MASK) );
+                        | (r_dma_cmd_to_tlb_vaddr.read()& K_PAGE_OFFSET_MASK) );
         
         // update TLB for a PTE2
@@ -1131,5 +1379,5 @@
                        pte_flags,
                        pte_ppn,
-                       r_dma_cmd_vaddr.read(),    
+                       r_dma_cmd_to_tlb_vaddr.read(),    
                        r_tlb_way.read(), 
                        r_tlb_set.read(),
@@ -1142,8 +1390,8 @@
 if ( m_debug_activated )
 {
-        std::cout << "  <IOB TLB_PTE2_UPDT> write PTE2 in IOTLB";
-        std::cout << " / set = " << std::dec << r_tlb_set.read()
-                  << " / way = " << r_tlb_way.read() << std::endl;
-        r_iotlb.printTrace();
+std::cout << "  <IOB TLB_PTE2_UPDT> write PTE2 in IOTLB"
+          << " / set = " << std::dec << r_tlb_set.read()
+          << " / way = " << r_tlb_way.read() << std::endl;
+r_iotlb.printTrace();
 }
 #endif
@@ -1156,9 +1404,9 @@
                      // PTE inval request are handled as unmaskable interrupts
     {
-        if ( r_config_tlb_req ) // Request from CONFIG FSM for a PTE invalidation 
+        if ( r_config_cmd_to_tlb_req.read() ) // Request for a PTE invalidation 
         {
-            r_config_tlb_req = false;
-            r_waiting_transaction = true;
-            r_tlb_fsm = TLB_INVAL_CHECK;
+            r_config_cmd_to_tlb_req = false;
+            r_waiting_transaction   = true;
+            r_tlb_fsm               = TLB_INVAL_CHECK;
         }
 
@@ -1166,12 +1414,12 @@
 m_cost_iotlbmiss_transaction++;
 #endif
-        if ( not r_tlb_miss_req )	//  Miss transaction is done 
+        if ( not r_tlb_to_miss_wti_cmd_req.read() )	//  Miss transaction completed
         { 
-	        if ( r_miss_wti_rsp_error.read() ) // bus error 
+	        if ( r_miss_wti_rsp_error_miss.read() ) // bus error reported
 	        {
-                r_miss_wti_rsp_error = false;
-                r_tlb_miss_error     = true;
-                r_dma_tlb_req        = false;
-                r_tlb_fsm            = TLB_IDLE;
+                r_miss_wti_rsp_error_miss = false;
+                r_tlb_miss_error          = true;
+                r_dma_cmd_to_tlb_req      = false;
+                r_tlb_fsm                 = TLB_IDLE;
             }
             else if(r_tlb_miss_type == PTE1_MISS)
@@ -1187,6 +1435,6 @@
     }
     ////////////////
-    case TLB_RETURN:		// reset r_dma_tlb_req flip-flop to signal TLB miss completion
-                            // possible errors are signaled through r_tlb_miss_error
+    case TLB_RETURN:   // reset r_dma_cmd_to_tlb_req to signal TLB miss completion
+                       // possible errors are signaled through r_tlb_miss_error
     {
 #if DEBUG_TLB_MISS
@@ -1194,5 +1442,5 @@
 std::cout << "  <IOB TLB_RETURN> IOTLB MISS completed" << std::endl;
 #endif
-        r_dma_tlb_req  = false;
+        r_dma_cmd_to_tlb_req  = false;
         r_tlb_fsm = TLB_IDLE;
         break;
@@ -1210,5 +1458,5 @@
             {
                if( r_tlb_buf_vaddr.read() == 
-                   (r_config_cmd_inval_vaddr.read()& ~PTE2_LINE_OFFSET) ) 
+                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE2_LINE_OFFSET) ) 
                 // The virtual address corresponds to one entry on the buffer line
                 {
@@ -1219,5 +1467,5 @@
             {
                if( r_tlb_buf_vaddr.read() == 
-                   (r_config_cmd_inval_vaddr.read()& ~PTE1_LINE_OFFSET) ) 
+                   (r_config_cmd_to_tlb_vaddr.read()& ~PTE1_LINE_OFFSET) ) 
                 // The virtual address corresponds to one entry on the buffer line
                 {
@@ -1229,5 +1477,5 @@
         // Invalidation on IOTLB
         bool    ok;
-        ok = r_iotlb.inval(r_config_cmd_inval_vaddr.read());
+        ok = r_iotlb.inval(r_config_cmd_to_tlb_vaddr.read());
          
         if(r_waiting_transaction.read()) r_tlb_fsm =TLB_WAIT; 
@@ -1239,13 +1487,14 @@
     ////////////////////////////////////////////////////////////////////////////////
     // The CONFIG_CMD_FSM handles the VCI commands from the INT network.
-    // This FSM can handle single flit config transactions, but it can also handle 
-    // software driven, multi-flits data transactions to ROM (read) or FBF (write).
+    // - it can be single flit config transactions
+    // - it can be multi-flits data transactions to ROM (read) or FBF (write).
     // The write burst transactions must be serialised from 32 to 64 bits width.
     // The configuration requests can be local (IO_BRIDGE config registers)
     // or remote (config registers of peripherals on IOX network).
-    // - The local configuration segment is identified by the "special" atribute.
+    // - The local configuration segment is identified by the "special" atribute
+    //   in the mapping table.
     // - All configuration requests are checkeg against segmentation violation.
     // - In case of local config request, or in case of segmentation violation,
-    //   the FSM put a VCI response request in CONFIG_RSP fifo.
+    //   the FSM send a response request to CONFIG_RSP FSM.
     // - In case of remote transaction, it put the VCI command in CONFIG_CMD fifo,
     //   and this require two cycles per IOX flit in case of write burst.
@@ -1296,5 +1545,5 @@
 
                 assert( (p_vci_tgt_int.be.read() == 0xF) and
-                "ERROR in vci_io_bridge : BE != 0xF for a config access");
+                "ERROR in vci_io_bridge : BE must be 0xF for a config access");
 
                 assert( ( eop ) and
@@ -1307,5 +1556,5 @@
                 else if ( read && (cell == IOB_IOMMU_PTPR) )      // READ PTPR 
                 {
-                    r_config_cmd_rdata = r_iommu_ptpr.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_ptpr.read();
                 }
                 else if( not read && (cell == IOB_WTI_ENABLE))  // WRITE WTI_ENABLE
@@ -1315,60 +1564,54 @@
                 else if( read && (cell == IOB_WTI_ENABLE))       // READ WTI ENABLE
                 {
-                    r_config_cmd_rdata = r_iommu_wti_enable.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_enable.read();
                 }
                 else if( read && (cell == IOB_IOMMU_BVAR))        // READ BVAR
                 {
-                    r_config_cmd_rdata = r_iommu_bvar.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_bvar.read();
                 }
                 else if( read && (cell == IOB_IOMMU_ETR))          // READ ETR
                 {
-                    r_config_cmd_rdata = r_iommu_etr.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_etr.read();
                 }
                 else if( read && (cell == IOB_IOMMU_BAD_ID))      // READ BAD_ID
                 {
-                    r_config_cmd_rdata = r_iommu_bad_id.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_bad_id.read();
                 }
                 else if( not read && (cell == IOB_INVAL_PTE))     // WRITE INVAL_PTE
                 {
-                    r_config_tlb_req         = true;
-                    r_config_cmd_inval_vaddr = (uint32_t)p_vci_tgt_int.wdata.read();
+                    r_config_cmd_to_tlb_req   = true;
+                    r_config_cmd_to_tlb_vaddr = (uint32_t)p_vci_tgt_int.wdata.read();
                 }
                 else if( not read && (cell == IOB_WTI_ADDR_LO)) // WRITE WTI_PADDR_LO
                 {
-                    r_iommu_wti_paddr = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                    r_iommu_wti_addr_lo = (vci_addr_t)p_vci_tgt_int.wdata.read();
                 }
                 else if( read && (cell == IOB_WTI_ADDR_LO))    // READ WTI_PADDR_LO
                 {
-                    r_config_cmd_rdata = (uint32_t)r_iommu_wti_paddr.read();
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_addr_lo.read();
                 }
                 else if( not read && (cell == IOB_WTI_ADDR_HI)) // WRITE WTI_PADDR_HI
                 {
-                    r_iommu_wti_paddr = (r_iommu_wti_paddr.read() & 0x00000000FFFFFFFFLL) |
-                                        ((vci_addr_t)p_vci_tgt_int.wdata.read())<<32;
+                    r_iommu_wti_addr_hi = (vci_addr_t)p_vci_tgt_int.wdata.read();
                 }
                 else if( read && (cell == IOB_WTI_ADDR_HI))    // READ WTI_PADDR_HI
                 {
-                    r_config_cmd_rdata = (uint32_t)(r_iommu_wti_paddr.read()>>32);
-                }
-                else if( not read && ((cell >= IOB_PERI_WTI_BEGIN)  // WRITE PERI WTI
-                          && (cell< (IOB_PERI_WTI_BEGIN + 64))) )
-                {
-                    size_t  index = (cell - IOB_PERI_WTI_BEGIN)/2;
-                    bool    high  = (cell - IOB_PERI_WTI_BEGIN)%2;
-                    if ( high ) r_iommu_peri_wti[index] =          // set 32 MSB bits
-                        (r_iommu_peri_wti[index].read() & 0x00000000FFFFFFFFLL) |
-                        ((vci_addr_t)p_vci_tgt_int.wdata.read())<<32;
-                    else        r_iommu_peri_wti[index] =          // set 32 LSB bits
-                         (vci_addr_t)p_vci_tgt_int.wdata.read();
-                } 
-                else if( read && ((cell >= IOB_PERI_WTI_BEGIN)      // READ PERI WTI    
-                         && (cell< (IOB_PERI_WTI_BEGIN + 64))) ) 
-                {
-                    size_t  index = (cell - IOB_PERI_WTI_BEGIN)/2;
-                    bool    high  = (cell - IOB_PERI_WTI_BEGIN)%2;
-                    if ( high ) r_config_cmd_rdata = 
-                                    (uint32_t)(r_iommu_peri_wti[index].read()>>32);
-                    else        r_config_cmd_rdata = 
-                                    (uint32_t)(r_iommu_peri_wti[index].read());
+                    r_config_cmd_to_config_rsp_rdata = r_iommu_wti_addr_hi.read();
+                }
+                else if( not read && (cell == IOB_XICU_BASE)) // WRITE XICU_BASE   
+                {
+                    r_xicu_base = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                }
+                else if( read && (cell == IOB_XICU_BASE))    // READ XICU_BASE   
+                {
+                    r_config_cmd_to_config_rsp_rdata = r_xicu_base.read();
+                }
+                else if( not read && (cell == IOB_XICU_SIZE)) // WRITE XICU_SIZE   
+                {
+                    r_xicu_size = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                }
+                else if( read && (cell == IOB_XICU_SIZE))    // READ XICU_SIZE   
+                {
+                    r_config_cmd_to_config_rsp_rdata = r_xicu_size.read();
                 }
                 else   // Error: Wrong address, or invalid operation.
@@ -1376,6 +1619,6 @@
                     rerror = true;
                 }
-                r_config_cmd_error = rerror;
-                r_config_cmd_fsm   = CONFIG_CMD_RSP;
+                r_config_cmd_to_config_rsp_rerror = rerror;
+                r_config_cmd_fsm                 = CONFIG_CMD_RSP;
             }
             else if ( found )                            // remote peripheral
@@ -1431,7 +1674,7 @@
             else                                         // out of segment address
             {
-                r_config_cmd_rdata  = 0;
-                r_config_cmd_error = true;
-                if( eop ) r_config_cmd_fsm = CONFIG_CMD_RSP;
+                r_config_cmd_to_config_rsp_rdata  = 0;
+                r_config_cmd_to_config_rsp_rerror = true;
+                if( eop ) r_config_cmd_fsm        = CONFIG_CMD_RSP;
             }
         } // end if cmdval
@@ -1460,5 +1703,5 @@
     }
     ////////////////////
-    case CONFIG_CMD_PUT:   // try to post a command to CONFIG_CMD fifo (to IOX network)
+    case CONFIG_CMD_PUT:   // post a command to CONFIG_CMD fifo (to IOX network)
     {
         config_cmd_fifo_put = true;
@@ -1480,23 +1723,19 @@
     }
     ////////////////////
-    case CONFIG_CMD_RSP:   // Try to put a response in CONFIG_RSP fifo, for
-                           // a local configuration transaction or a segment error.
-                           // The FIFO is shared with CONFIG_RSP FSM 
-                           // and must we wait for allocation...
-    {
-        if ( r_alloc_fifo_config_rsp_local.read() )
+    case CONFIG_CMD_RSP:   // Post a request to CONFIG_RSP FSM, 
+                           // if no previous pending request.
+                           // r_config_cmd_to_config_rsp_rerror
+                           // has been set in IDLE state. 
+    {
+        if ( not r_config_cmd_to_config_rsp_req.read() )
         {
-            config_rsp_fifo_put = true;
-
-            if ( m_config_rsp_data_fifo.wok() )  
-            {
+            r_config_cmd_to_config_rsp_req = true;
 
 #if DEBUG_CONFIG_CMD
 if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_CMD_RSP> Response to a local configuration request" 
-          << std::endl;
-#endif
-                r_config_cmd_fsm = CONFIG_CMD_IDLE;
-            }
+std::cout << "  <IOB CONFIG_CMD_RSP> Request a response to CONFIG_RSP FSM"
+          << " / error = " << r_config_cmd_to_config_rsp_rerror.read() << std::endl;
+#endif
+            r_config_cmd_fsm = CONFIG_CMD_IDLE;
         }
         break;
@@ -1505,8 +1744,11 @@
 
     //////////////////////////////////////////////////////////////////////////////
-    // The CONFIG_RSP_FSM handles the 64 bits VCI responses from the periherals 
-    // on the IOX network and  writes the responses in the CONFIG_RSP fifo.
-    // This FSM handle both single flit config responses, and multi-flits
-    // read responses (ROM), where data must be serialised (64 bits -> 32 bits). 
+    // The CONFIG_RSP_FSM controls access to the CONFIG_RSP FIFO to INT network.
+    // It implements a round robin priority between 2 clients FSMs :
+    // - CONFIG_CMD : response to a local config command.
+    // - CONFIG_RSP : responses from peripherals on IOX network
+    // Regarding the responses from IOX network it handles both single flit 
+    // config responses, and multi-flits read responses (ROM), where data must 
+    // be serialised (64 bits -> 32 bits). 
     // Note: We use the VCI RPKTID field to distinguish between read cached
     // (multi-flits response) and others (single flit response).
